SystemOrganization addCategory: #'JQueryMobile-Samples-Flickr'!

!GRPackage class methodsFor: '*jquerymobile-samples-flickr' stamp: 'NickAger 11/2/2011 16:33'!
jQueryMobileSamplesFlickr
	^ self new
		name: 'JQueryMobile-Samples-Flickr';
		description: 'jQueryMobile Flickr Samples';
		addDependency:  'JQueryMobile-Canvas';
		addDependency:  'JQueryMobile-Email';
		addDependency:  'JQueryMobile-Tools';
		addDependency: 'JQueryMobile-Scripting';
		addDependency: 'JQueryMobile-BookmarkBubble';
		addDependency: 'JQueryMobile-Decorations';
		addDependency: 'Seaside-Component';
		addDependency: 'Seaside-Core';
		url: #seasideUrl;
		yourself
		
	! !

WADecoration subclass: #JQMSampleFlickrToolbar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrToolbar methodsFor: 'as yet unclassified' stamp: 'NickAger 11/3/2011 12:41'!
renderContentOn: html
	html div
		jqmHeader;
 	     with: [
  	       html anchor
			jqmIcon: 'home';
			jqmReverse;
			jqmIconNoText;
			callback: [ self decoratedComponent answer ].
		html heading
  	          level1;
   	         with: 'Flickr photos' ].
	
	super renderContentOn: html. ! !

WAComponent subclass: #JQMSampleFlickrBase
	instanceVariableNames: 'flickrTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrBase methodsFor: 'accessing' stamp: 'NickAger 11/3/2011 11:54'!
flickrTag
	^ flickrTag ifNil: [ flickrTag := 'JQueryMobile' ]! !

!JQMSampleFlickrBase methodsFor: 'accessing' stamp: 'NickAger 11/3/2011 11:54'!
flickrTag: anObject
	flickrTag := anObject! !

!JQMSampleFlickrBase methodsFor: 'as yet unclassified' stamp: 'NickAger 11/3/2011 12:46'!
initialize 
	super initialize.
	
	self addDecoration: JQMSampleFlickrToolbar new.
	self addDecoration: JQMIOSHomescreenBookmarkDecorator new.! !

JQMSampleFlickrBase subclass: #JQMSampleFlickrHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrHome methodsFor: 'as yet unclassified' stamp: 'NickAger 11/3/2011 12:43'!
initialize 
	super initialize.
	self addDecoration: JQMBookmarkBubbleDecoration new.! !

!JQMSampleFlickrHome methodsFor: 'rendering' stamp: 'NickAger 11/3/2011 12:30'!
renderContentOn: html
	html div
		jqmContent;
		with: [
			html paragraph: 'Enter a tag to retrieve Flickr photos:'.
			self renderFormOn: html ]! !

!JQMSampleFlickrHome methodsFor: 'rendering' stamp: 'NickAger 11/3/2011 12:28'!
renderFormOn: html
	html form: [
		html textInput
			on: #flickrTag of: self.

		html  submitButton 
			callback: [ self show: (JQMSampleFlickrSlideShow flickrTag: self flickrTag)  ];
			with: 'View Slide Show' ]! !

JQMSampleFlickrBase subclass: #JQMSampleFlickrSlideShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrSlideShow class methodsFor: 'instance creation' stamp: 'NickAger 11/3/2011 11:56'!
flickrTag: flickrTag 
	^ self new
		flickrTag: flickrTag! !

!JQMSampleFlickrSlideShow methodsFor: 'as yet unclassified' stamp: 'NickAger 11/3/2011 12:27'!
renderButtonsOn: html
	html button
		jqmInline;
		onClick: 'showImage(currentImageIndex - 1)';
		with: 'previous'.
		
	html button
		jqmInline;
		onClick: 'showImage(currentImageIndex + 1)';
		with: 'next'.
	! !

!JQMSampleFlickrSlideShow methodsFor: 'as yet unclassified' stamp: 'NickAger 11/3/2011 12:34'!
renderContentOn: html
	html div
		jqmContent;
		with: [
			self renderButtonsOn: html.
			self renderJSOn: html.

			html div
				id: #images;
				onSwipeLeft: 'showImage(currentImageIndex - 1)';
				onSwipeRight: 'showImage(currentImageIndex + 1)'.
			
			html  paragraph: [
				html text: 'Photos for tag: '; text: self flickrTag ] ]! !

!JQMSampleFlickrSlideShow methodsFor: 'as yet unclassified' stamp: 'NickAger 11/3/2011 12:27'!
renderJSOn: html
	html script: '
	var currentImageIndex = 0;
	var showImage = function (imageIndex) {
		var maxImageIndex = $("#images").children().length - 1;
		imageIndex = imageIndex < 0 ? maxImageIndex : imageIndex;
		imageIndex = imageIndex > maxImageIndex ? 0 : imageIndex;
			
		
		$($("#images").children()[currentImageIndex]).hide();
		$($("#images").children()[imageIndex]).show();
		currentImageIndex = imageIndex;
	}'.
	
	html document addLoadScript: 
		(html jQuery getJson
			url: 'http://api.flickr.com/services/feeds/photos_public.gne?tags=', self flickrTag , '&format=json&jsoncallback=?';
			onSuccess: '$.each(arguments[0].items, function (index, item) {
				$("#images").append($("<img>").attr("src", item.media.m).hide());
				showImage(0);
			}) ').! !
